"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var react_1 = require("@storybook/react");
var with_readme_1 = require("storybook-readme/with-readme");
var _1 = require("../");
var Readme = require("./README/Gauge.md");
var data = [
    {
        value: 8,
        name: 'Vanilla',
        color: 'beige'
    },
    {
        value: 9,
        name: 'Chocolate',
        color: 'brown'
    },
    {
        value: 7,
        name: 'Strawberry',
        color: 'pink'
    }
];
var singleSegment = [
    {
        value: 0,
        name: 'Vanilla',
        color: 'beige'
    },
    {
        value: 0,
        name: 'Chocolate',
        color: 'brown'
    },
    {
        value: 2,
        name: 'Strawberry',
        color: 'pink'
    }
];
var zeroCountPlaceholder = 'red';
var zeroCount = [
    {
        value: 0,
        name: 'Chocolate',
        color: 'brown'
    },
    {
        value: 0,
        name: 'Strawberry',
        color: 'pink'
    }
];
react_1.storiesOf('Core/Gauge', module)
    .addDecorator(with_readme_1.default(Readme))
    .add('Standard', function () {
    return React.createElement(_1.Gauge, { m: 30, title: 'Ice Cream', data: data });
})
    .add('Single segment', function () {
    return React.createElement(_1.Gauge, { m: 30, title: 'Ice Cream', data: singleSegment });
})
    .add('Zero count', function () {
    return (React.createElement(_1.Gauge, { m: 30, title: 'Ice Cream', data: zeroCount, placeholderColor: zeroCountPlaceholder }));
});
